package org.objectweb.fractal.bf.adl.exporter;

import java.io.PrintWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

import org.objectweb.fractal.bf.BindingFactoryException;
import org.objectweb.fractal.bf.adl.common.Parameter;

/**
 * Exporter builder meant to be used with the static backed of the Fractal-BF
 * ADL.
 */
public class StaticExporterBuilder implements ExporterBuilder {
	Logger log = Logger.getLogger(StaticExporterBuilder.class
			.getCanonicalName());

	/**
	 * @see org.objectweb.fractal.bf.adl.exporter.ExporterBuilder#export(java.lang.String,
	 *      java.lang.Object, java.util.List, java.lang.String,
	 *      java.lang.Object)
	 */
	public void export(String itfName, Object component,
			List<Parameter> parameters, String type, Object context)
			throws BindingFactoryException {
		PrintWriter pw = (PrintWriter) ((Map<?, ?>) context).get("printwriter");
		log.finest("PrintWriter for static exporter builder: " + pw);

		pw.write(Map.class.getCanonicalName()
				+ "<String,String> exportHints = new "
				+ HashMap.class.getCanonicalName() + "<String,String>();\n");
		for (Parameter p : parameters) {
			// xportHints.put(p.getName(), p.getValue());
			pw.write("exportHints.put(\"" + p.getName() + "\",\""
					+ p.getValue() + "\");\n");
		}
		pw
				.write("BindingFactory bf = BindingFactoryHelper.getBindingFactory();\n");
		pw.write("Component component = (Component)" + component + ";\n");
		pw.write("bf.export(component, \"" + itfName + "\", exportHints);\n");
	}

}
